"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const disposable_1 = require("@lumino/disposable");
const vega_lite_1 = require("vega-lite");
const PLUGIN_ID = 'jupyterlab-omnisci:extract-vega-lite-plugin';
const plugin = {
    activate,
    id: PLUGIN_ID,
    autoStart: true
};
exports.default = plugin;
const COMM_TARGET = 'extract-vega-lite';
function commTarget(comm, msg) {
    const spec = msg.content.data;
    const extractedSpec = vega_lite_1.extractTransforms(spec, {});
    comm.send(extractedSpec);
}
function createNew(nb, context) {
    context.sessionContext.kernelChanged.connect((_, { newValue, oldValue }) => {
        if (oldValue) {
            oldValue.removeCommTarget(COMM_TARGET, commTarget);
        }
        if (newValue) {
            newValue.registerCommTarget(COMM_TARGET, commTarget);
        }
    });
    return new disposable_1.DisposableDelegate(() => {
        // Don't know how to get current kernel anymore
        // if (context.sessionContext.kernel) {
        //   context.sessionContext.kernel.removeCommTarget(COMM_TARGET, commTarget);
        // }
    });
}
function activate(app) {
    app.docRegistry.addWidgetExtension('Notebook', { createNew });
}
