import { JSONObject } from '@lumino/coreutils';
import { Widget } from '@lumino/widgets';
import { IOmniSciConnectionData } from './connection';
/**
 * A class for rendering a OmniSci-generated image.
 */
export declare class OmniSciVega extends Widget {
    /**
     * Construct a new OmniSci widget.
     */
    constructor(options: OmniSciVega.IOptions);
    readonly renderedImage: Promise<string>;
    private _renderData;
    /**
     * Set the image data to a base64 encoded string.
     */
    private _setImageData;
    private _rendered;
    private _vega;
    private _vegaLite;
    private _connectionPromise;
    private _img;
    private _error;
}
/**
 * A namespace for OmniSciVega statics.
 */
export declare namespace OmniSciVega {
    /**
     * Options used to create a new OmniSciVega widget.
     */
    interface IOptions {
        /**
         * The vega spec to render.
         */
        vega: JSONObject;
        /**
         * Connection information.
         */
        connection: IOmniSciConnectionData;
        /**
         * An optional vega-lite spec which was used to generate the vega spec.
         * Only used for debugging purposes, can be shown upon errors.
         */
        vegaLite?: JSONObject;
        /**
         * An optional session ID for a pre-authenticated session.
         */
        sessionId?: string;
    }
}
